/**
A PShape tutorial by <a href="http://www.local-guru.net/blog"> guru</a>
*/

PShape ofig;
PShape fig;

PShape body;
PShape left_arm;
PShape right_arm;
PShape left_leg;
PShape right_leg;

void setup() {
  size(500,500);
  fig = loadShape( "figure2.svg" );
  body = fig.getChild( "body" );
  left_arm = fig.getChild( "left_arm" );
  right_arm = fig.getChild( "right_arm" );
  left_leg = fig.getChild( "left_leg" );
  right_leg = fig.getChild( "right_leg" );
  
  left_arm.getChild( "pivot_left_arm").setVisible( false );
  right_arm.getChild( "pivot_right_arm").setVisible( false );
  left_leg.getChild( "pivot_left_leg").setVisible( false );
  right_leg.getChild( "pivot_right_leg").setVisible( false );

}

void draw() {
  background(255);
 
  shape( fig, 0, 0 );
  
}

float r_arm = 0;
float r_leg = 0;

void mouseMoved() {
  float a = radians(mouseY - pmouseY);
  
  if ( r_arm+a < HALF_PI && r_arm + a  > -HALF_PI ) {
    r_arm += a;
 
    rotateShape( left_arm, "pivot_left_arm", a);
    rotateShape( right_arm, "pivot_right_arm", -a);
  }
  
  if ( r_leg+a < 0 && r_leg + a  > -PI/3) {
  r_leg += a;
  rotateShape( left_leg, "pivot_left_leg", a);  
  rotateShape( right_leg, "pivot_right_leg", -a);  
  
  }
}

void rotateShape( PShape s, String pivot, float a ) {
  float[] p = s.getChild( pivot ).getParams();
  float px = p[0];
  float py = p[1];
  s.translate( px, py );
  s.rotate( a );
  s.translate( -px, -py );
}
